#ifndef IPERSON_H
#define IPERSON_H

#include <iostream>
#include <string>

using namespace std;

class IPerson
{
public:
    IPerson() {}
    IPerson(const string& name, const string& surename, unsigned int age):
        m_name(name), m_surename(surename), m_age(age) {}
    virtual ~IPerson() {}


    virtual void print(ostream& output) const = 0;
    virtual const string& getName() const { return m_name; }
    virtual const string& getSurename() const { return m_surename; }
    virtual unsigned int getAge() const { return m_age; }


private:
    string m_name;
    string m_surename;
    unsigned int m_age;
};

#endif // IPERSON_H
