#include <iostream>
#include <fstream>
#include "Loader.h"

Loader::~Loader()
{
    Deinit();
}

//------------------------------------

void Loader::loadAll(const string& file)
{
    ifstream input(file.c_str());

    loadAll(input);

    input.close();
}

//------------------------------------

void Loader::loadAll(istream& input)
{
    Deinit();

    if(!input)
        return;

    while(input.good())
    {
        string type, name, surename;
        unsigned int age;

        input >> type >> name >> surename >> age;

        if(input.fail())
            break;

        IPerson* newPerson;
        if(type == "student")
        {
            newPerson = new CStudent(name, surename, age);
        }
        else if(type == "ucitel")
        {
            newPerson = new CTeacher(name, surename, age);
        }
        else if(type == "absolvent")
        {
            newPerson = new CAbsolvent(name, surename, age);
        }
        else
        {
            cerr << "Nepodporovany typ!" << endl;
        }

        m_list.push_back(newPerson);
    }
}

//------------------------------------

void Loader::printAll() const
{
    for(list<IPerson*>::const_iterator i = m_list.begin();
        i != m_list.end(); i++)
    {
        (*i)->print(cout);
    }
}

//------------------------------------

void Loader::Deinit()
{
    for(list<IPerson*>::iterator i = m_list.begin();
        i != m_list.end(); i++)
    {
        delete *i;
    }

    m_list.clear();
}
